Index: trunk/demos/CircleFollower/simulator/resources/core2-64/simulator_x4.sh
===================================================================
--- trunk/demos/CircleFollower/simulator/resources/core2-64/simulator_x4.sh	(revision 435)
+++ trunk/demos/CircleFollower/simulator/resources/core2-64/simulator_x4.sh	(revision 469)
@@ -6,5 +6,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -n x4_0 -t x4 -p 9000 -a 127.0.0.1 -x simulator_x4.xml -o 10 -m $FLAIR_ROOT/flair-src/models -s $FLAIR_ROOT/flair-src/models/indoor_flight_arena.xml
Index: trunk/demos/CircleFollower/simulator/resources/core2-64/simulator_x8.sh
===================================================================
--- trunk/demos/CircleFollower/simulator/resources/core2-64/simulator_x8.sh	(revision 435)
+++ trunk/demos/CircleFollower/simulator/resources/core2-64/simulator_x8.sh	(revision 469)
@@ -1,5 +1,3 @@
 #! /bin/bash
-
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
 
 if [ -f /proc/xenomai/version ];then
Index: trunk/demos/CircleFollower/uav/resources/core2-64/x4.sh
===================================================================
--- trunk/demos/CircleFollower/uav/resources/core2-64/x4.sh	(revision 435)
+++ trunk/demos/CircleFollower/uav/resources/core2-64/x4.sh	(revision 469)
@@ -7,5 +7,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -n x4_0 -a 127.0.0.1 -p 9000 -l /tmp -x setup_x4.xml -t x4_simu 
Index: trunk/demos/CircleFollower/uav/resources/core2-64/x4_intelaero.sh
===================================================================
--- trunk/demos/CircleFollower/uav/resources/core2-64/x4_intelaero.sh	(revision 435)
+++ trunk/demos/CircleFollower/uav/resources/core2-64/x4_intelaero.sh	(revision 469)
@@ -7,5 +7,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -n x4_0 -a 172.26.213.62 -p 9000 -l /tmp -x setup_x4_intelaero.xml -t aero
Index: trunk/demos/CircleFollower/uav/resources/core2-64/x8.sh
===================================================================
--- trunk/demos/CircleFollower/uav/resources/core2-64/x8.sh	(revision 435)
+++ trunk/demos/CircleFollower/uav/resources/core2-64/x8.sh	(revision 469)
@@ -7,5 +7,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -n x8_0 -a 127.0.0.1 -p 9000 -l ./ -x setup_x8.xml -t x8_simu
Index: trunk/demos/DemoGps/simulator/resources/core2-64/simulator_x4.sh
===================================================================
--- trunk/demos/DemoGps/simulator/resources/core2-64/simulator_x4.sh	(revision 435)
+++ trunk/demos/DemoGps/simulator/resources/core2-64/simulator_x4.sh	(revision 469)
@@ -7,5 +7,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -n x4_0 -t x4 -p 9000 -a 127.0.0.1 -x simulator_x4.xml -o 10 -m $FLAIR_ROOT/flair-src/models -s $FLAIR_ROOT/flair-src/models/indoor_flight_arena.xml
Index: trunk/demos/DemoGps/simulator/resources/core2-64/simulator_x8.sh
===================================================================
--- trunk/demos/DemoGps/simulator/resources/core2-64/simulator_x8.sh	(revision 435)
+++ trunk/demos/DemoGps/simulator/resources/core2-64/simulator_x8.sh	(revision 469)
@@ -7,5 +7,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -n x8_0 -t x8 -p 9000 -a 127.0.0.1 -x simulator_x8.xml -o 10 -m $FLAIR_ROOT/flair-src/models -s $FLAIR_ROOT/flair-src/models/indoor_flight_arena.xml
Index: trunk/demos/DemoGps/uav/resources/core2-64/x4.sh
===================================================================
--- trunk/demos/DemoGps/uav/resources/core2-64/x4.sh	(revision 435)
+++ trunk/demos/DemoGps/uav/resources/core2-64/x4.sh	(revision 469)
@@ -7,5 +7,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -n x4_0 -a 127.0.0.1 -p 9000 -l /tmp -x setup_x4.xml -t x4_simu
Index: trunk/demos/DemoGps/uav/resources/core2-64/x8.sh
===================================================================
--- trunk/demos/DemoGps/uav/resources/core2-64/x8.sh	(revision 435)
+++ trunk/demos/DemoGps/uav/resources/core2-64/x8.sh	(revision 469)
@@ -7,5 +7,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -n x8_0 -a 127.0.0.1 -p 9000 -l ./ -x setup_x8.xml -t x8_simu
Index: trunk/demos/DemoOpticalFlow/simulator/resources/core2-64/simulator_x4.sh
===================================================================
--- trunk/demos/DemoOpticalFlow/simulator/resources/core2-64/simulator_x4.sh	(revision 435)
+++ trunk/demos/DemoOpticalFlow/simulator/resources/core2-64/simulator_x4.sh	(revision 469)
@@ -7,5 +7,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -n x4_0 -t x4 -a 127.0.0.1 -p 9000 -x simulator_x4.xml -o 10 -m $FLAIR_ROOT/flair-src/models -s $FLAIR_ROOT/flair-src/models/indoor_flight_arena.xml
Index: trunk/demos/DemoOpticalFlow/simulator/resources/core2-64/simulator_x8.sh
===================================================================
--- trunk/demos/DemoOpticalFlow/simulator/resources/core2-64/simulator_x8.sh	(revision 435)
+++ trunk/demos/DemoOpticalFlow/simulator/resources/core2-64/simulator_x8.sh	(revision 469)
@@ -7,5 +7,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -n x8_0 -t x8 -a 127.0.0.1 -p 9000 -x simulator_x8.xml -o 10 -m $FLAIR_ROOT/flair-src/models -s $FLAIR_ROOT/flair-src/models/indoor_flight_arena.xml
Index: trunk/demos/DemoOpticalFlow/uav/resources/core2-64/x4.sh
===================================================================
--- trunk/demos/DemoOpticalFlow/uav/resources/core2-64/x4.sh	(revision 435)
+++ trunk/demos/DemoOpticalFlow/uav/resources/core2-64/x4.sh	(revision 469)
@@ -7,5 +7,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -n x4_0 -a 127.0.0.1 -p 9000 -l /tmp -x setup_x4.xml -t x4_simu -v dsp_stub
Index: trunk/demos/DemoOpticalFlow/uav/resources/core2-64/x8.sh
===================================================================
--- trunk/demos/DemoOpticalFlow/uav/resources/core2-64/x8.sh	(revision 435)
+++ trunk/demos/DemoOpticalFlow/uav/resources/core2-64/x8.sh	(revision 469)
@@ -7,5 +7,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -n x8_0 -a 127.0.0.1 -p 9000 -l /tmp -x setup_x8.xml -t x8_simu -v dsp_stub
Index: trunk/demos/MixedReality/real/simulator/resources/core2-64/simulator_x4.sh
===================================================================
--- trunk/demos/MixedReality/real/simulator/resources/core2-64/simulator_x4.sh	(revision 435)
+++ trunk/demos/MixedReality/real/simulator/resources/core2-64/simulator_x4.sh	(revision 469)
@@ -6,5 +6,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -p 9000 -a 127.0.0.1 -x simulator_x4.xml -o 10 -m $FLAIR_ROOT/flair-src/models -s $FLAIR_ROOT/flair-src/models/indoor_flight_arena.xml
Index: trunk/demos/MixedReality/real/uav/resources/core2-64/x4.sh
===================================================================
--- trunk/demos/MixedReality/real/uav/resources/core2-64/x4.sh	(revision 435)
+++ trunk/demos/MixedReality/real/uav/resources/core2-64/x4.sh	(revision 469)
@@ -7,5 +7,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -a 127.0.0.1 -p 9000 -l /tmp -x setup_x4.xml -t x4_simu0 -v 127.0.0.1:3884 -d 20010
Index: trunk/demos/MixedReality/virtual/simulator/resources/core2-64/simulator_x4.sh
===================================================================
--- trunk/demos/MixedReality/virtual/simulator/resources/core2-64/simulator_x4.sh	(revision 435)
+++ trunk/demos/MixedReality/virtual/simulator/resources/core2-64/simulator_x4.sh	(revision 469)
@@ -6,5 +6,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -p 9000 -a 127.0.0.1 -x simulator_x4.xml -o 10 -m $FLAIR_ROOT/flair-src/models -s $FLAIR_ROOT/flair-src/models/indoor_flight_arena.xml -v 127.0.0.1:3883
Index: trunk/demos/MixedReality/virtual/uav/resources/core2-64/x4.sh
===================================================================
--- trunk/demos/MixedReality/virtual/uav/resources/core2-64/x4.sh	(revision 435)
+++ trunk/demos/MixedReality/virtual/uav/resources/core2-64/x4.sh	(revision 469)
@@ -7,5 +7,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -a 127.0.0.1 -p 9000 -l /tmp -x setup_x4.xml -t x4_simu1
Index: trunk/demos/PidStandalone/simulator/resources/core2-64/simulator_x4.sh
===================================================================
--- trunk/demos/PidStandalone/simulator/resources/core2-64/simulator_x4.sh	(revision 435)
+++ trunk/demos/PidStandalone/simulator/resources/core2-64/simulator_x4.sh	(revision 469)
@@ -7,5 +7,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -n x4_0 -t x4 -a 127.0.0.1 -p 9000 -x simulator_x4.xml -o 10 -m $FLAIR_ROOT/flair-src/models -s $FLAIR_ROOT/flair-src/models/indoor_flight_arena.xml
Index: trunk/demos/PidStandalone/simulator/resources/core2-64/simulator_x8.sh
===================================================================
--- trunk/demos/PidStandalone/simulator/resources/core2-64/simulator_x8.sh	(revision 435)
+++ trunk/demos/PidStandalone/simulator/resources/core2-64/simulator_x8.sh	(revision 469)
@@ -7,5 +7,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC  -n x8_0 -t x8 -a 127.0.0.1 -p 9000 -x simulator_x8.xml -o 10 -m $FLAIR_ROOT/flair-src/models -s $FLAIR_ROOT/flair-src/models/indoor_flight_arena.xml
Index: trunk/demos/PidStandalone/uav/resources/core2-64/x4.sh
===================================================================
--- trunk/demos/PidStandalone/uav/resources/core2-64/x4.sh	(revision 435)
+++ trunk/demos/PidStandalone/uav/resources/core2-64/x4.sh	(revision 469)
@@ -6,5 +6,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -n x4_0 -a 127.0.0.1 -p 9000 -l ./ -x setup_x4.xml -t x4_simu $*
Index: trunk/demos/PidStandalone/uav/resources/core2-64/x8.sh
===================================================================
--- trunk/demos/PidStandalone/uav/resources/core2-64/x8.sh	(revision 435)
+++ trunk/demos/PidStandalone/uav/resources/core2-64/x8.sh	(revision 469)
@@ -7,5 +7,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -n x8_0 -a 127.0.0.1 -p 9000 -l ./ -x setup_x8.xml -t x8_simu
Index: trunk/demos/SimpleFleet/simulator/resources/core2-64/simulator_x4.sh
===================================================================
--- trunk/demos/SimpleFleet/simulator/resources/core2-64/simulator_x4.sh	(revision 435)
+++ trunk/demos/SimpleFleet/simulator/resources/core2-64/simulator_x4.sh	(revision 469)
@@ -7,5 +7,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -n x4 -a 127.0.0.1 -p 9000 -x simulator_x4.xml -o 10 -m $FLAIR_ROOT/flair-src/models -s $FLAIR_ROOT/flair-src/models/indoor_flight_arena.xml -t x4
Index: trunk/demos/SimpleFleet/simulator/resources/core2-64/simulator_x8.sh
===================================================================
--- trunk/demos/SimpleFleet/simulator/resources/core2-64/simulator_x8.sh	(revision 435)
+++ trunk/demos/SimpleFleet/simulator/resources/core2-64/simulator_x8.sh	(revision 469)
@@ -7,5 +7,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -n x8 -a 127.0.0.1 -p 9000 -x simulator_x8.xml -o 10 -m $FLAIR_ROOT/flair-src/models -s $FLAIR_ROOT/flair-src/models/indoor_flight_arena.xml -t x8
Index: trunk/demos/SimpleFleet/uav/resources/core2-64/x4_0.sh
===================================================================
--- trunk/demos/SimpleFleet/uav/resources/core2-64/x4_0.sh	(revision 435)
+++ trunk/demos/SimpleFleet/uav/resources/core2-64/x4_0.sh	(revision 469)
@@ -7,5 +7,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -n x4_0 -a 127.0.0.1 -p 9000 -l ./ -x setup_x4.xml -t x4_simu0 -b 127.255.255.255:20010
Index: trunk/demos/SimpleFleet/uav/resources/core2-64/x4_1.sh
===================================================================
--- trunk/demos/SimpleFleet/uav/resources/core2-64/x4_1.sh	(revision 435)
+++ trunk/demos/SimpleFleet/uav/resources/core2-64/x4_1.sh	(revision 469)
@@ -7,5 +7,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -n x4_1 -a 127.0.0.1 -p 9000 -l ./ -x setup_x4.xml -t x4_simu1 -b 127.255.255.255:20010 -d 21000
Index: trunk/demos/SimpleFleet/uav/resources/core2-64/x8_0.sh
===================================================================
--- trunk/demos/SimpleFleet/uav/resources/core2-64/x8_0.sh	(revision 435)
+++ trunk/demos/SimpleFleet/uav/resources/core2-64/x8_0.sh	(revision 469)
@@ -7,5 +7,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -n x8_0 -a 127.0.0.1 -p 9000 -l ./ -x setup_x8.xml -t x8_simu0 -b 127.255.255.255:20010
Index: trunk/demos/SimpleFleet/uav/resources/core2-64/x8_1.sh
===================================================================
--- trunk/demos/SimpleFleet/uav/resources/core2-64/x8_1.sh	(revision 435)
+++ trunk/demos/SimpleFleet/uav/resources/core2-64/x8_1.sh	(revision 469)
@@ -7,5 +7,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -n x8_1 -a 127.0.0.1 -p 9000 -l ./ -x setup_x8.xml -t x8_simu1 -b 127.255.255.255:20010 -d 21000
Index: trunk/demos/Sinus/resources/core2-64/Sinus.sh
===================================================================
--- trunk/demos/Sinus/resources/core2-64/Sinus.sh	(revision 435)
+++ trunk/demos/Sinus/resources/core2-64/Sinus.sh	(revision 469)
@@ -6,6 +6,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC
-
Index: trunk/demos/TwoWheelRobotCircleFollower/simulator/resources/core2-64/simulator.sh
===================================================================
--- trunk/demos/TwoWheelRobotCircleFollower/simulator/resources/core2-64/simulator.sh	(revision 435)
+++ trunk/demos/TwoWheelRobotCircleFollower/simulator/resources/core2-64/simulator.sh	(revision 469)
@@ -6,5 +6,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -n ugv_0 -p 9000 -a 127.0.0.1 -x simulator.xml -o 10 -m $FLAIR_ROOT/flair-src/models -s $FLAIR_ROOT/flair-src/models/indoor_flight_arena.xml
Index: trunk/demos/TwoWheelRobotCircleFollower/ugv/resources/core2-64/ugv_simu.sh
===================================================================
--- trunk/demos/TwoWheelRobotCircleFollower/ugv/resources/core2-64/ugv_simu.sh	(revision 435)
+++ trunk/demos/TwoWheelRobotCircleFollower/ugv/resources/core2-64/ugv_simu.sh	(revision 469)
@@ -7,5 +7,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -n ugv_0 -t ugv_simu -a 127.0.0.1 -p 9000 -l /tmp -x setup_simu.xml
Index: trunk/demos/TwoWheelRobotCircleFollower/ugv/resources/core2-64/ugv_sumo.sh
===================================================================
--- trunk/demos/TwoWheelRobotCircleFollower/ugv/resources/core2-64/ugv_sumo.sh	(revision 435)
+++ trunk/demos/TwoWheelRobotCircleFollower/ugv/resources/core2-64/ugv_sumo.sh	(revision 469)
@@ -7,5 +7,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -n ugv_0 -t sumo -a 127.0.0.1 -p 9000 -l /tmp -x setup_sumo.xml
Index: trunk/demos/TwoWheelRobotSimpleFleet/simulator/resources/core2-64/simulator.sh
===================================================================
--- trunk/demos/TwoWheelRobotSimpleFleet/simulator/resources/core2-64/simulator.sh	(revision 435)
+++ trunk/demos/TwoWheelRobotSimpleFleet/simulator/resources/core2-64/simulator.sh	(revision 469)
@@ -6,5 +6,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -n ugv -p 9000 -a 127.0.0.1 -x simulator.xml -o 10 -m $FLAIR_ROOT/flair-src/models -s $FLAIR_ROOT/flair-src/models/indoor_flight_arena.xml
Index: trunk/demos/TwoWheelRobotSimpleFleet/ugv/resources/core2-64/ugv_simu0.sh
===================================================================
--- trunk/demos/TwoWheelRobotSimpleFleet/ugv/resources/core2-64/ugv_simu0.sh	(revision 435)
+++ trunk/demos/TwoWheelRobotSimpleFleet/ugv/resources/core2-64/ugv_simu0.sh	(revision 469)
@@ -7,5 +7,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -n ugv_0 -t ugv_simu0 -a 127.0.0.1 -p 9000 -l /tmp -x setup_simu0.xml -b 127.255.255.255:20010
Index: trunk/demos/TwoWheelRobotSimpleFleet/ugv/resources/core2-64/ugv_simu1.sh
===================================================================
--- trunk/demos/TwoWheelRobotSimpleFleet/ugv/resources/core2-64/ugv_simu1.sh	(revision 435)
+++ trunk/demos/TwoWheelRobotSimpleFleet/ugv/resources/core2-64/ugv_simu1.sh	(revision 469)
@@ -7,5 +7,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -n ugv_1 -t ugv_simu1 -a 127.0.0.1 -p 9000 -l /tmp -x setup_simu1.xml -b 127.255.255.255:20010 -d 21000
Index: trunk/demos/TwoWheelRobotSimpleFleet/ugv/resources/core2-64/ugv_sumo0.sh
===================================================================
--- trunk/demos/TwoWheelRobotSimpleFleet/ugv/resources/core2-64/ugv_sumo0.sh	(revision 435)
+++ trunk/demos/TwoWheelRobotSimpleFleet/ugv/resources/core2-64/ugv_sumo0.sh	(revision 469)
@@ -7,5 +7,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -n ugv_0 -t sumo -a 127.0.0.1 -p 9000 -l /tmp -x setup_sumo0.xml -b 172.26.223.255:20010
Index: trunk/demos/TwoWheelRobotSimpleFleet/ugv/resources/core2-64/ugv_sumo1.sh
===================================================================
--- trunk/demos/TwoWheelRobotSimpleFleet/ugv/resources/core2-64/ugv_sumo1.sh	(revision 435)
+++ trunk/demos/TwoWheelRobotSimpleFleet/ugv/resources/core2-64/ugv_sumo1.sh	(revision 469)
@@ -7,5 +7,3 @@
 fi
 
-. $FLAIR_ROOT/flair-src/scripts/distribution_specific_hack.sh
-
 $EXEC -n ugv_1 -t sumo -a 127.0.0.1 -p 9000 -l /tmp -x setup_sumo1.xml -b 172.26.223.255:20010